#!/bin/bash
# Works through each users list of requests in the 'searches' directory then:
# a. sends an email to them (using the results.htm file)
# b. copies the file to a local web server

TARGET=/var/www/minerva/warp/conf/tvguide
ETCDIR=/usr/local/minerva/etc/users

pushd ~minerva/update/tv >/dev/null

for user in `ls $ETCDIR`; do
 echo "Processing list for $user"

 ./tvsearch.sh $ETCDIR/$user/tvsearch/list $user
 
 if [ -f $ETCDIR/$user/tvsearch/email ]
 then
    cat results.htm | mail -a "Content-Type: text/html;" -s "TV programmes for `date +'%A %e' -d '2 tomorrow'`" `head -n 1 searches/$i/email`;
 fi;


done

popd

