<?php
require_once 'warp/warplib/applet.inc';
require_once 'warp/warplib/appletutils.inc';
require_once 'sunrise.php';
require_once 'cal.php';

include_once 'warp/conf/calendar/gcal.conf';

class Warp_Calendar_Applet extends Warp_Applet
{
var $cal;
var $showMonth;
var $showYear;

	function Warp_Calendar_Applet($caption = "Calendar")
	{
            parent::__construct($caption);
	}

        function getID() { return "MIN001A"; }

        function getDirectory()
        {
            return "calendar";
        }

        function init(&$appMan)
        {
            Warp_Applet::Init($appMan);

	    $this->cal = new Calendar($appMan, $this);
            $this->showMonth = $appMan->QueryParameter($this, "month");
            $this->showYear  = $appMan->QueryParameter($this, "year");
        }

        function renderPanel(&$app_man)
        {
        $date =  date("l")."<br><b>".date("jS F")."</b><br>".date("Y");
	$date.= "<br/>";
        $date.= "<div id='theClock'>   </div>";
	return "<div align=center>$date</div>";
        }

        function renderWindow(&$app_man)
        {
$clock = <<<END
<applet
codebase="http://oskamp.dyndns.org/SiemensClock/Java/"
code="SiemensClock.class"
archive="SiemensClock.jar" 
width="512" height="512">
<param name="type" value="application/x-java-applet;version=1.4">
<param name="scriptable" value="false">
<param name="centerX"    value="256">
<param name="centerY"    value="256">
<param name="handScale"  value="176">
<param name="BGImage" value="http://oskamp.dyndns.org/SiemensClock/Java/SiemensClock-512x512.png">
</applet>

END
;
	$d = getdate(time());
        $month = $this->showMonth;
        $year = $this->showYear;
	if ($month == "") { $month = $d["mon"]; }
	if ($year == "") { $year = $d["year"]; }

        $monthView = $this->cal->getMonthViewApp($app_man,$this, $month, $year);
        $monthView.="<hr>";
        $monthView.=$this->getLifeStatus();
        $monthView.="<p><hr>";
        $monthView.=$this->getWeeklyEvents();
        $monthView.="<p><hr>";
        $monthView.=$this->getGCalLinks();

        $info = "<p><hr>";
	$info.= "Sunrise:<b>".getSunRise()."</b><br/>";
        $info.= "Sunset:<b>".getSunSet()."</b>";

        $calendar = $app_man->getView()->split2H($monthView, $info);

	return $app_man->getView()->split2V($clock, $calendar);
        }

        function renderConfig(&$app_man, $fast=false)
        {
           if ($fast) { return "-"; }

           return "What sort of configuration are you expecting for a calender? Are you nuts? :)";
        }

        function getLifeStatus(){
           return exec("/usr/local/minerva/bin/lstatus");
        }

        function getTodaysEvents($name, $url) {
           $contents = appletUtils::getContents($url, "cal_$name", 6000);

           $regex = "/BEGIN:VEVENT.*?DTSTART;[^:]*:([^\s]*).*?SUMMARY:([^\n]*).*?END:VEVENT/is";
            preg_match_all($regex, $contents, $matches, PREG_SET_ORDER);

          $all = "";

          $nowseconds = time();
          $dayofseconds = 60*60*24;
          for($i=0;$i<sizeof($matches);++$i) {
              $secs = date('U', strtotime($matches[$i][1]));

              if ($secs < $nowseconds) continue;
              if ($secs> $nowseconds+$dayofseconds) continue;

              $event = strftime("%A %d %b %Y.", strtotime($matches[$i][1]));
              $event .= " ".$matches[$i][2].".";
              $event .= strftime("%l%P.", strtotime($matches[$i][1]));
              $all = $event.$all;
           }

          return $all;
        }


        function getICalEvents($name, $url) {
            $contents = appletUtils::getContents($url, "cal_$name", 6000);

          $regex = "/BEGIN:VEVENT.*?DTSTART;[^:]*:([^\s]*).*?SUMMARY:([^\n]*).*?END:VEVENT/is";
            preg_match_all($regex, $contents, $matches, PREG_SET_ORDER);

          $all = "";

          $nowseconds = time();
          $weekofseconds = 604800;
          for($i=0;$i<sizeof($matches);++$i) {
              $secs = date('U', strtotime($matches[$i][1]));

              if ($secs < $nowseconds) continue;
              if ($secs> $nowseconds+$weekofseconds) continue;

              $event  = "<li>";
              $event .= strftime("%A %d %b %Y.", strtotime($matches[$i][1]));
              $event .= " ".$matches[$i][2].".";
              $event .= strftime("%l%P.", strtotime($matches[$i][1]));
              $event .= "</li>";
              $all = $event.$all;
           }

          if ($all != "") {
               $all ="<i>from $name</i><ul>$all</ul>";
          }
          return $all;
        }

        function getWeeklyEvents() 
        {
           $gcals = Warp_GoogleCalendar_Config::getICalList();
           if (sizeof($gcals) > 0) {
              $ev = "<b>Forthcoming events:</b><br/>";
              foreach($gcals AS $name => $url) {
                 $ev.= $this->getICalEvents($name, $url);
              }
           }

           return $ev;
         }

        function getGCalLinks() 
        {
           $gcals = Warp_GoogleCalendar_Config::getCalendars();

           if (sizeof($gcals) > 0) {
              $cal .= "<b>View complete calendar:</b><br/>";
              foreach($gcals AS $name => $url) {
                 $cal .= "&nbsp;&nbsp;";
                 $cal .= "<a href=$url>$name</a><br/>";
              }
           }
           return $cal;
        }

	function getHeadHTML(&$app_man)
	{
           return <<< HERE
           <LINK rel="stylesheet" href="warp/applets/calendar/calendar.css" type="text/css">

<script language="JavaScript">

<!--

var clockID = 0;

function UpdateClock()
{
	if(clockID) 
	{
		clearTimeout(clockID);
		clockID  = 0;
	}

var date = new Date();
var hr = ""+date.getHours();
var min= ""+date.getMinutes();
var sec= ""+date.getSeconds();

	if (hr.length ==1) hr="0"+hr;
	if (min.length==1) min="0"+min;
	if (sec.length==1) sec="0"+sec;

	document.getElementById('theClock').innerHTML = hr+":"+min+":"+sec;

	clock = setTimeout("UpdateClock()", 1000);
}

function StartClock()
{
   clock = setTimeout("UpdateClock()", 500);
}

function KillClock()
{
	if(clock)
	{
		clearTimeout(clock);
		clock = 0;
	}
}
//-->
</script>
HERE;
	}

	function getBodyParams(&$app_man, &$params)
	{
		$params["onload"][] = "UpdateClock()";
		$params["onunload"][] = "KillClock()";
	}

function getRefreshParams(&$app_man)
{
   if ($this->showMonth != "") {
      $ref.= $app_man->getArgument($this, "month", $this->showMonth);
   }

   if ($this->showYear != "") {
      $ref.= $app_man->getArgument($this, "year", $this->showYear);
   }

   return $ref;
}


    function renderInfo(&$app_man, $fast=false)
    {
        if ($fast) {
            return "-";
        }

        return <<<EOD
<p>A standard applet with a clock and calendar. Events are taken from
Google calendar, by adding the publically accessible URL to <tt>warp/conf/calendar/gcal.conf</tt>. The clock uses an external Java applet, and can be removed
to save time.</p>
EOD;
    }

}

?>

